## hubzero-mw2-client 2.2.8

=== Makefile ===
--- 
+++ 
@@ -67,9 +67,8 @@
 	install --mode 0640 -D mw2-client.conf $(ETC)/mw-client/mw2-client.conf
 
 manual_install:  install postinst
-	chmod -R 770 /etc/mw-client
-	chown $(WEBUSER):$(WEBUSER) /etc/mw-client
-	chown $(WEBUSER):$(WEBUSER) /etc/mw-client/mw2-client.conf
+	chmod -R o-rwx /etc/mw-client
+	chown -R $(WEBUSER):$(WEBUSER) /etc/mw-client
 	# change umask to avoid race conditions with later chmod commands
 	umask 0077
 	if [ ! -f /etc/mw-client/maxwell.key.pub ]; then \
@@ -87,8 +86,11 @@
 	chown $(WEBUSER):$(WEBUSER) /etc/mw-client/notify.key
 	chown $(WEBUSER):$(WEBUSER) /etc/mw-client/notify.key.pub
 
+	# prevent "Permissions 0770 for '/etc/mw-client/maxwell.key' are too open. This private key will be ignored."
+	chmod 0700 /etc/mw-client/maxwell.key
+
 	# install notify public key in web service user's authorized_keys file
-	if [ ! -d $(WEBUSER)/.ssh ]; then \
+	if [ ! -d ~$(WEBUSER)/.ssh ]; then \
 	  mkdir -p ~$(WEBUSER)/.ssh; \
 	  chown $(WEBUSER):$(WEBUSER) ~$(WEBUSER)/.ssh; \
 	fi
@@ -100,7 +102,6 @@
 	# make sure .ssh/authorized_keys is writable, and add the public key to notify
 	grep -q -f /etc/mw-client/notify.key.pub ~$(WEBUSER)/.ssh/authorized_keys || \
 	  su -s /bin/sh -c "chmod u+w ~$(WEBUSER)/.ssh/authorized_keys; echo -n 'COMMAND=\"/usr/bin/maxwell notify\" ' >> ~$(WEBUSER)/.ssh/authorized_keys; cat /etc/mw-client/notify.key.pub >> ~$(WEBUSER)/.ssh/authorized_keys" $(WEBUSER); \
-	fi
 
 	# setup permissions for /var/log/mw-client
 	chown $(WEBUSER):$(WEBUSER) /var/log/mw-client
@@ -122,13 +123,13 @@
 	chown $(WEBUSER):$(WEBUSER) /etc/mw-client/maxwell.key.pub
 	chmod 0400 /etc/mw-client/maxwell.key.pub
 	chown $(WEBUSER):$(WEBUSER) /etc/mw-client/maxwell.key
-	chmod 0400 /etc//mw-client/maxwell.key
+	chmod 0400 /etc/mw-client/maxwell.key
 	chown $(WEBUSER):$(WEBUSER) /etc/mw-client/notify.key.pub
 	chmod 0400 /etc/mw-client/notify.key.pub
 	chown $(WEBUSER):$(WEBUSER) /etc/mw-client/notify.key
 	chmod 0400 /etc/mw-client/notify.key
-	if [ -f /etc/mw-client/notify.key -a -d $(ETCDIR)/mw-service/notify.key ]; then cp /etc/mw-client/notify.key /etc/mw-service/notify.key; fi
-	if [ -f /etc/mw-service/notify.key ]; then chown root:root $(ETCDIR)/mw-service/notify.key; chmod 0400 /etc/mw-service/notify.key; fi	
+	if [ -f /etc/mw-client/notify.key -a -d $(ETC)/mw-service/notify.key ]; then cp /etc/mw-client/notify.key /etc/mw-service/notify.key; fi
+	if [ -f /etc/mw-service/notify.key ]; then chown root:root $(ETC)/mw-service/notify.key; chmod 0400 /etc/mw-service/notify.key; fi	
 
 clean:
 	rm -f $(USRBIN)/maxwell
