=== debian/changelog ===
hubzero-mw2-client (2.2.11-1+deb9) unstable; urgency=low

  * add Debian 9 support
  * fix tuple vs list database issue
  * in renotify, process most recent sessions first and limit to 1000 sessions

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 19 Aug 2020 17:20:58 -0700

hubzero-mw2-client (2.2.10-1) unstable; urgency=low

  * update copyright/trademark ownership
  * update email address references
  * remove per file @author references
  * update copyright years

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Sat, 02 May 2020 12:52:51 -0700

hubzero-mw2-client (2.2.9-1) unstable; urgency=low

  * bug fix for logging in check_host
  * added MOUNT_FOREIGN option to configuration file
  * import make_User_account to support foreign mounts (hydroshare)
  * fix packaging for multihost builds

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 09 Oct 2019 14:44:16 -0500

hubzero-mw2-client (2.2.8-1) unstable; urgency=low

  * reconnect to database as needed when processing notification
    from execution host
  * close db connections before contacting fileserver
  * close db connections before contacting fileserver
  * show traceback on DEBUG instead of VERBOSE, and set DEBUG to
    False by default

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Thu, 18 Apr 2019 10:41:49 -0500

hubzero-mw2-client (2.2.7-1) unstable; urgency=low

  * Don't clobber config file on rpm update

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Tue, 19 Feb 2019 15:56:23 -0500

hubzero-mw2-client (2.2.6-1) unstable; urgency=low

  * WIP docker support
  * improve standby container support
  * support for newer versions of mysqldb python library
  * support of osp configuration 

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Tue, 19 Feb 2019 15:15:30 -0400

hubzero-mw2-client (2.2.5-1) unstable; urgency=low

  * Add dependencies for debian packaging

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Tue, 26 Jun 2018 11:31:50 -0400

hubzero-mw2-client (2.2.4-1) unstable; urgency=low

  * Restore erroneously removed configuration lines

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Mon, 25 Jun 2018 16:53:06 -0400

hubzero-mw2-client (2.2.3-1) unstable; urgency=low

  * Change debian control to mark package to conflict/replace hubzero-mw-client

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Mon, 25 Jun 2018 13:19:21 -0400

hubzero-mw2-client (2.2.2-1) unstable; urgency=low

  * Replace changeme placeholders with hubinabox valid defaults

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Wed, 20 Jun 2018 14:33:12 -0400

hubzero-mw2-client (2.2.1-1) unstable; urgency=low

  * Debian packaging update

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Mon, 18 Jun 2018 16:31:24 -0400

hubzero-mw2-client (2.2.0-1) unstable; urgency=low

  * Debian packaging update

 -- Nicholas J. Kisseberth <nkisseberth@ucsd.edu>  Tue, 10 Apr 2018 16:51:42 -0400

hubzero-mw2-client (2.1.6-1) unstable; urgency=low

  * removed reference to dev.nanohub.org in configuration file

 -- Pascal Meunier <pmeunier@purdue.edu>  Thu, 29 Mar 2018 14:01:20 -0400

hubzero-mw2-client (2.1.5-1) unstable; urgency=low

  * fixed comment in SSH key creation
  * better error reporting and detection if mysql connection variables aren't set

 -- Pascal Meunier <pmeunier@purdue.edu>  Tue, 27 Mar 2018 10:17:20 -0400

hubzero-mw2-client (2.1.4-1) unstable; urgency=low

  * use /etc/mw-client/mw2-client.conf for configuration instead of /etc/mw-client/mw-client.conf

 -- Pascal Meunier <pmeunier@purdue.edu>  Tue, 20 Mar 2018 15:33:21 -0400

hubzero-mw2-client (2.1.3-1) unstable; urgency=low

  * mount foreign username/org filesystems with username mapping using jos_auth_ tables
  * recursively set permissions on /var/log/mw-client

 -- Pascal Meunier <pmeunier@purdue.edu>  Fri, 23 Feb 2018 11:17:19 -0400

hubzero-mw2-client (2.1.2-3) unstable; urgency=low

  * avoid doing chmod -R 0770 because it makes pre-existing private keys readable by group, which SSH rejects

 -- Pascal Meunier <pmeunier@purdue.edu>  Thu, 17 Aug 2017 16:50:13 -0400

hubzero-mw2-client (2.1.2-2) unstable; urgency=low

  * Package signing

 -- Pascal Meunier <pmeunier@purdue.edu>  Wed, 16 Aug 2017 10:45:29 -0400

hubzero-mw2-client (2.1.2-1) unstable; urgency=low

  * mw-client.conf uncomment table prefix

 -- Pascal Meunier <pmeunier@purdue.edu>  Thu, 20 Apr 2017 14:35:31 -0400

hubzero-mw2-client (2.1.1-1) unstable; urgency=low

  * mw-client.conf updated and modified to leverage hzcms --enable

 -- Pascal Meunier <pmeunier@purdue.edu>  Thu, 13 Apr 2017 16:22:57 -0400

hubzero-mw2-client (2.1.0-1) unstable; urgency=low

  * Initial packaging.

 -- Pascal Meunier <pmeunier@purdue.edu>  Thu, 12 Jan 2017 11:31:15 -0400
