=== debian/control ===
Source: hubzero-mw2-client
Section: misc
Priority: optional
Maintainer: Nicholas J. Kisseberth <nkisseberth@ucsd.edu>
Build-Depends: debhelper (>= 8.0.0)
Standards-Version: 3.8.4
X-Python-Version: >= 2.6
Homepage: http://hubzero.org

Package: hubzero-mw2-client
Architecture: all
Depends: python (>=2.6), hubzero-mw2-common, time, openssh-client, openssh-server, python, socat, stunnel4, python-dns, ${misc:Depends}
Conflicts: hubzero-mw-client
Replaces: hubzero-mw-client
Description: HUBzero Middleware 2 Client
 Client for HUBzero Middleware 2
